/*
 *   -- micMAGMA (version 0.1) --
 *      Univ. of Tennessee, Knoxville
 *      Univ. of California, Berkeley
 *      Univ. of Colorado, Denver
 *      April 2012
 *
 *   @author Azzam Haidar
 *   @author Khairul Kabir 
 *
 *   @generated d Fri Nov 22 14:21:23 2013
 */

#ifndef MAGMA_D_BINDINGS
#define MAGMA_D_BINDINGS
typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dcopy_param;

typedef struct {
    magma_trans_t transa;
    magma_trans_t transb;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
} magma_mic_dgemm_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_dsymm_param;

typedef struct {
    magma_trans_t transa;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dgemv_param;

typedef struct {
    magma_trans_t uplo;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dsymv_param;

typedef struct {
    magma_trans_t uplo;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr x;
    magma_int_t incx;
    double beta;
    magmaDouble_const_ptr y;
    magma_int_t incy;
} magma_mic_dsymv2_param;



typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
} magma_mic_dsyrk_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_dsyrk_mmic_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t agboff;
} magma_mic_dsyr2k_param;

typedef struct {
    magma_uplo_t uplo;
    magma_trans_t trans;
    magma_int_t n;
    magma_int_t k;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magma_int_t aoff;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
    magma_int_t boff;
    double beta;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magma_int_t offset;
    magma_int_t nb;
    magma_int_t nmic;
    magma_int_t my_id;
} magma_mic_dsyr2k_mmic_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
} magma_mic_dtrsm_param;

typedef struct {
    magma_mic_dtrsm_param trsm_param;
    magma_mic_dgemm_param gemm_param;
} magma_mic_dtrsmgemm_param;

typedef struct {
  magma_uplo_t uplo;
  magma_trans_t trans;
  magma_diag_t diag;
  magma_int_t n;
  double alpha;
  magmaDouble_const_ptr a;
  magma_int_t lda;
  magmaDouble_const_ptr dx;
  magma_int_t incx;
} magma_mic_dtrsv_param;

typedef struct {
  magma_uplo_t uplo;
  magma_trans_t trans;
  magma_diag_t diag;
  magma_int_t n;
  double alpha;
  magmaDouble_const_ptr a;
  magma_int_t lda;
  magmaDouble_const_ptr dx;
  magma_int_t incx;
} magma_mic_dtrmv_param;
 
typedef struct {
    int direct;
    int storev;
    magma_int_t n;
    magma_int_t k;
    magmaDouble_const_ptr v;
    magma_int_t ldv;
    magmaDouble_const_ptr tau;
    magmaDouble_const_ptr t;
    magma_int_t ldt;
} magma_mic_dlarft_param;


typedef struct {
    magma_int_t side;
    magma_int_t trans;
    magma_int_t direct;
    magma_int_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaDouble_const_ptr v;
    magma_int_t ldv;
    magmaDouble_const_ptr t;
    magma_int_t ldt;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magmaDouble_const_ptr work;
    magma_int_t ldwork;
} magma_mic_dlarfb_param;

typedef struct {
    magma_int_t side;
    magma_int_t trans;
    magma_int_t direct;
    magma_int_t storev;
    magma_int_t m;
    magma_int_t n;
    magma_int_t k;
    magmaDouble_const_ptr v;
    magma_int_t ldv;
    magmaDouble_const_ptr t;
    magma_int_t ldt;
    magmaDouble_const_ptr c;
    magma_int_t ldc;
    magmaDouble_const_ptr work;
    magma_int_t ldwork;
    magmaDouble_const_ptr workvt;
    magma_int_t ldworkvt;
} magma_mic_dlarfb_gemm_param;

typedef struct {
    magma_uplo_t uplo;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    double beta;
    magmaDouble_const_ptr dA;
    magma_int_t lda;
} magma_mic_dlaset_param;

typedef struct {
    magma_side_t side;
    magma_uplo_t uplo;
    magma_trans_t transa;
    magma_diag_t diag;
    magma_int_t m;
    magma_int_t n;
    double alpha;
    magmaDouble_const_ptr a;
    magma_int_t lda;
    magmaDouble_const_ptr b;
    magma_int_t ldb;
} magma_mic_dtrmm_param;


typedef struct {
    magmaDouble_const_ptr odata;
    magma_int_t ldo;
    magmaDouble_const_ptr idata;
    magma_int_t ldi;
    magma_int_t m;
    magma_int_t n;
} magma_mic_dtranspose_param;


/*
typedef struct {
    magmaDouble_const_ptr d_AT;
    magma_int_t lda;
    magma_int_t *d_ipiv;
    magma_int_t nb;
    magma_int_t ind;
} magma_mic_dlaswp_param;
*/


typedef struct {
    magma_int_t n;
    magmaDouble_const_ptr d_A;
    magma_int_t lda;
    magma_int_t k1;
    magma_int_t k2;
    magma_int_t *d_ipiv;
    magma_int_t incx;
} magma_mic_dlaswp_param;


typedef struct {
    magma_int_t n;
    double *dA1T;
    magma_int_t lda1;
    double *dA2T;
    magma_int_t lda2;
} magma_mic_dswap_param;

#endif  // MAGMA_D_BINDINGS
